var MAP_MSG_DEFAULT_SEARCH_TEXT 	= '住所、又はスポット名を入力してください';
var MAP_MSG_NOT_FOUND_SEARCH_TEXT	= '見つかりませんでした';

var MAP_THRESHOLD_LEVEL_LOW_SIZE	= 180;
var MAP_THRESHOLD_LEVEL_MEDIUM_SIZE	= 240;
var MAP_THRESHOLD_LEVEL_HIGH_SIZE	= 320;

ACMS.GMap = {};


google.load('maps', '2', {'callback' : function()
{
    function parseQuery(url, alt)
    {
        var query	= url.substr(url.indexOf('?') + 1);
        var params	= new Array();
        $(query.split('&')).each(function(){
            var t	= this.split('=');
            params[t[0]]	= t[1];
        });

        var latLng          = params['center'].split(',');
        var xy              = params['size'].split('x');
        var zoom            = params['zoom'];
        var msgs            = alt.split('[[:split:]]');
        var markers         = params['markers'].split('%7C');

        return {
            'lat'   : latLng[0],
            'lng'   : latLng[1],
            'x'     : xy[0],
            'y'     : xy[1],
            'zoom'  : zoom,
            'msgs'  : msgs,
            'markers': markers
        };
    }

    function genMap(elm, w, h)
    {
        var mapElm          = document.createElement('div');
        mapElm.className    = elm.className;
        mapElm.style.width  = w + 'px';
        mapElm.style.height = h + 'px';
        elm.parentNode.replaceChild(mapElm, elm);
        return new google.maps.Map2(mapElm);
    }


    function addControl(map, width)
    {
        if ( width < MAP_THRESHOLD_LEVEL_LOW_SIZE ) {
        } else if ( width < MAP_THRESHOLD_LEVEL_MEDIUM_SIZE ) {
            map.addControl(new google.maps.SmallMapControl());
        } else if ( width < MAP_THRESHOLD_LEVEL_HIGH_SIZE ) {
            map.addControl(new google.maps.SmallMapControl());
            map.addControl(new google.maps.MapTypeControl());
        } else {
            map.addControl(new google.maps.LargeMapControl());
            map.addControl(new google.maps.MapTypeControl());
            map.addControl(new google.maps.ScaleControl());
            map.addControl(new google.maps.OverviewMapControl());
        }
    }

    function addMarker(map, markers, msgs, width)
    {
        $(markers).each(function(i){
            var latLng	= this.split(',');
            var gmarker	= new google.maps.Marker(new google.maps.LatLng(latLng[0], latLng[1]));
            var msg		= msgs[i];
            if ( !!(msg) && (MAP_THRESHOLD_LEVEL_LOW_SIZE <= width) ) {
                void function(gmarker, msg)
                {
                    google.maps.Event.addListener(gmarker, 'click', function()
                    {
                        gmarker.openInfoWindowHtml(msg);
                        return true;
                    });
                }(gmarker, msgs[i].replace(/\[\[:quot:\]\]/igm, '"').replace(/\[\[:lt:\]\]/igm, '<').replace(/\[\[:gt:\]\]/igm, '>').replace(/\[\[:amp:\]\]/igm, '&'));
            }
            map.addOverlay(gmarker);
        });
    }

    /**
     *
     *
     *
     **/
    ACMS.GMap.init = function ($mapimgs) {
	$mapimgs.each(
	    function()
	    {
		var $wrapper    = $(this).parents('.formColumnMap');
		if ( $wrapper.size() ) {
		    var Q   = ACMS.GMap.parseQuery(this.src, this.alt);
		    var map = ACMS.GMap.genMap(this, Q.x, Q.y);

		    ACMS.GMap.addControl(map, Q.x);
		    map.setCenter(new google.maps.LatLng(Q.lat, Q.lng), parseInt(Q.zoom, 10));

		    var mLatLng = Q.markers[0].split(',');
		    var marker  = new google.maps.Marker(new google.maps.LatLng(mLatLng[0], mLatLng[1]), {draggable:true});
		    map.addOverlay(marker);

		    var geocoder = new google.maps.ClientGeocoder();

		    var $iLat   = $('input:text[name^="map_lat"]', $wrapper);
		    var $iLng   = $('input:text[name^="map_lng"]', $wrapper);
		    var $iZoom  = $('input:text[name^="map_zoom"]', $wrapper);

		    function latlng_change_handler (ev) {
			var p = new google.maps.LatLng($iLat.val(), $iLng.val());
			map.panTo(p);
			marker.setPoint(p);
		    }

		    //------------
		    // lat change
		    $iLat.change(latlng_change_handler);
		    //------------
		    // lng change
		    $iLng.change(latlng_change_handler);
		    //-------------
		    // zoom change
		    $iZoom.change(
			function(){
			    map.setZoom(parseInt($iZoom.val(), 10));
			}
		    );
		    //-----------------
		    // zoomend
		    google.maps.Event.addListener(
			map,
			'zoomend',
			function(oldLv, newLv) {
			    $iZoom.val(newLv);
			}
		    );
		    //-------------
		    // dragend
		    google.maps.Event.addListener(
			marker,
			'dragend',
			function() {
			    var point = marker.getPoint();
			    var lat   = point.y;
			    var lng   = point.x;
			    lat = Math.round(lat*1000000);
			    lng = Math.round(lng*1000000);
			    $iLat.val(lat/1000000);
			    $iLng.val(lng/1000000);
			    map.panTo(point);
			}
		    );

		    var $sTxt   = $('input:text[name="mapSearchTexts[]"]', $wrapper);
		    $sTxt.val(MAP_MSG_DEFAULT_SEARCH_TEXT).attr('disabled', false);
		    var $sBtn   = $('input:button[name="mapSearchButtons[]"]', $wrapper);
		    $sBtn.attr('disabled', false);

		    $sBtn.after(
			'<input type="submit" name="mapSearchSubmits[]" value="'
			    + $sBtn.attr('value') + '" />'
		    );
		    var $sSubmit= $('input:submit[name="mapSearchSubmits[]"]', $wrapper);
		    $sSubmit.hide();

		    $sTxt.focus(
			function() {
			    if ( MAP_MSG_DEFAULT_SEARCH_TEXT == $(this).val() ) $(this).val('');
			    $('input:submit', this.form).attr('disabled', true);

			    $sBtn.hide();
			    $sSubmit.attr('disabled', false).show();

			    $(this.form).submit(function(){return false;});
			})
		    ;
		    //
		    $sTxt.blur(
			function() {
			    if ( '' == $(this).val() ) $(this).val(MAP_MSG_DEFAULT_SEARCH_TEXT);
			    $(this.form).unbind('submit');
			    $('input:submit', this.form).attr('disabled', false);
			    $sBtn.show();
			    $sSubmit.hide();
			}
		    );

		    function search() {
			var addres  = $sTxt.val();
			if ( !addres ) return false;
			$sBtn.attr('disable', true);
			$sSubmit.attr('disable', true);
			geocoder.getLatLng(
			    addres,
			    function(point) {
				if ( !point ) {
				    $sTxt.val(MAP_MSG_NOT_FOUND_SEARCH_TEXT);
				} else {
				    map.panTo(point);
				    marker.setPoint(point);
				    var lat = point.y;
				    var lng = point.x;
				    lat = Math.round(lat*1000000);
				    lng = Math.round(lng*1000000);
				    $iLat.val(lat/1000000);
				    $iLng.val(lng/1000000);
				}
				$sBtn.attr('disable', false);
				$sSubmit.attr('disable', false);
			    }
			);
			return false;
		    }

		    $sBtn.click(search);
		    $sSubmit.click(search);

		} else {
		    $(this).click(
			function() {
			    var Q   = parseQuery(this.src, this.alt);
			    var map = genMap(this, Q['x'], Q['y']);

			    ACMS.GMap.addControl(map, Q['x']);
			    map.setCenter(new google.maps.LatLng(Q['lat'], Q['lng']), parseInt(Q['zoom'], 10));
			    ACMS.GMap.addMarker(map, Q['markers'], Q['msgs'], Q['x']);
			}
		    );
		}
	    }
	);
    };


    ACMS.GMap.parseQuery = parseQuery;
    ACMS.GMap.genMap     = genMap;
    ACMS.GMap.addControl = addControl;
    ACMS.GMap.addMarker  = addMarker;

    ACMS.GMap.init(window.$columnMaps);
    delete window.$columnMaps;
}});
